uniform mat4 modelMatrix;
uniform float worldScale;

// varying vec3 c;
varying float depthCorrection;
varying vec3 vPosition;
varying vec3 e;
varying vec3 n;

uniform vec3 c;
uniform vec3 color0;
uniform vec3 color1;
uniform vec3 color2;
uniform float squash0;
uniform float squash1;
uniform float squash2;
uniform float radius1;
uniform float radius2;
uniform float soften;

void main() {
	float scalar = 100000.0;
	vec3 center = c / scalar;
	vec3 pos = vPosition;// / scalar;
	vec3 color = vec3(0);
	float distance, val;
	vec3 x0, x1, x2;

	//Base disc
	x0 = center;
	x1 = cameraPosition;
	x1.y /= squash0;
	x2 = pos;
	x2.y /= squash0;

	distance = clamp(length(cross(x0-x1, x0-x2))/length(x2-x1), 0.0, 1.0);

	val = sqrt(1.0 - distance*distance);
	color += color0 * pow(val, soften);

	//Soft glow
	x1 = cameraPosition;
	x1.y /= squash1;
	x2 = pos;
	x2.y /= squash1;

	distance = clamp(length(cross(x0-x1, x0-x2))/length(x2-x1), 0.0, 1.0);

	val = sqrt(radius1*radius1 - distance*distance);
	color += color1 * pow(clamp(val/radius1, 0.0, 1.0), soften);


	//Central glow
	x1 = cameraPosition;
	x1.y /= squash2;
	x2 = pos;
	x2.y /= squash2;

	distance = clamp(length(cross(x0-x1, x0-x2))/length(x2-x1), 0.0, 1.0);

	val = sqrt(radius2*radius2 - distance*distance);
	color += color2 * pow(clamp(val/radius2, 0.0, 1.0), soften);



	gl_FragColor = vec4(color, 1.0);

	float falloff = 1.0;
	float power = pow(abs(dot(-e, n)), falloff);
	gl_FragColor = vec4(color*power, 1.0);
	// gl_FragColor = vec4(vec3(1.0-power), 1.0);
}